//---------------------------------------------------------------------------------------
//  FILE:    XComCharacterVoiceBank_X2
//  AUTHOR:  Ryan McFall
//  PURPOSE: Support for voice packs in mods - this works just like EU/EW style voices
//---------------------------------------------------------------------------------------
//  Copyright (c) 2016 Firaxis Games, Inc. All rights reserved.
//---------------------------------------------------------------------------------------
class XComCharacterVoiceBank_X2 extends XComCharacterVoiceBank	
	hidecategories(Object);

//Contains new speech events for X2 - combined with the speech events for base XCOM ( some of which are used in X2 and some which can be re purposed )
var() SoundCue ALERT <SpeechEvent = ALERT>;
var() SoundCue EngagingHostiles <SpeechEvent = EngagingHostiles>;
var() SoundCue Halt <SpeechEvent = Halt>;
var() SoundCue MovementSpotted <SpeechEvent = MovementSpotted>;
var() SoundCue RequestReinforcements <SpeechEvent = RequestReinforcements>;
var() SoundCue TargetSighted <SpeechEvent = TargetSighted>;
var() SoundCue DeathScream <SpeechEvent = DeathScream>;
var() SoundCue CivilianScream <SpeechEvent = CivilianScream>;
var() SoundCue EvacAllDead <SpeechEvent = EvacAllDead>;
var() SoundCue EvacAllOut <SpeechEvent = EvacAllOut>;
var() SoundCue EvacSomeOut <SpeechEvent = EvacSomeOut>;
var() SoundCue ObjectSecured <SpeechEvent = ObjectSecured>;
var() SoundCue EVACrequest <SpeechEvent = EVACrequest>;
var() SoundCue InDropPosition <SpeechEvent = InDropPosition>;
var() SoundCue TargetCaptured <SpeechEvent = TargetCaptured>;
var() SoundCue ObjectivePackageEVAC <SpeechEvent = ObjectivePackageEVAC>;
var() SoundCue ADVENTsighting <SpeechEvent = ADVENTsighting>;
var() SoundCue TargetHeard <SpeechEvent = TargetHeard>;
var() SoundCue ObjectiveSighted <SpeechEvent = ObjectiveSighted>;
var() SoundCue VIPsighted <SpeechEvent = VIPsighted>;
var() SoundCue CivilianSighted <SpeechEvent = CivilianSighted>;
var() SoundCue TrippedBurrow <SpeechEvent = TrippedBurrow>;
var() SoundCue ActivateConcealment <SpeechEvent = ActivateConcealment>;
var() SoundCue EnemyPatrolSpotted <SpeechEvent = EnemyPatrolSpotted>;
var() SoundCue EnterSquadConcealment <SpeechEvent = EnterSquadConcealment>;
var() SoundCue OverWatch <SpeechEvent = OverWatch>;
var() SoundCue MovingConcealed <SpeechEvent = MovingConcealed>;
var() SoundCue OrderConfirm <SpeechEvent = OrderConfirm>;
var() SoundCue ConcealedSpotted <SpeechEvent = ConcealedSpotted>;
var() SoundCue AlienExperimentSighted <SpeechEvent = AlienExperimentSighted>;
var() SoundCue AlienFacilitySighted <SpeechEvent = AlienFacilitySighted>;
var() SoundCue AlienFloraSighted <SpeechEvent = AlienFloraSighted>;
var() SoundCue AmmoOut <SpeechEvent = AmmoOut>;
var() SoundCue ArmorHit <SpeechEvent = ArmorHit>;
var() SoundCue AttemptingHack <SpeechEvent = AttemptingHack>;
var() SoundCue BlasterLauncher <SpeechEvent = BlasterLauncher>;
var() SoundCue BulletShred <SpeechEvent = BulletShred>;
var() SoundCue CapacitorDischarge <SpeechEvent = CapacitorDischarge>;
var() SoundCue CheckpointSighted <SpeechEvent = CheckpointSighted>;
var() SoundCue CivilianRescue <SpeechEvent = CivilianRescue>;
var() SoundCue Confused <SpeechEvent = Confused>;
var() SoundCue CoupDeGrace <SpeechEvent = CoupDeGrace>;
var() SoundCue DefensiveProtocol <SpeechEvent = DefensiveProtocol>;
var() SoundCue Dodge <SpeechEvent = Dodge>;
var() SoundCue Domination <SpeechEvent = Domination>;
var() SoundCue DroppingBody <SpeechEvent = DroppingBody>;
var() SoundCue EVAC <SpeechEvent = EVAC>;
var() SoundCue FanFire <SpeechEvent = FanFire>;
var() SoundCue GenericSighting <SpeechEvent = GenericSighting>;
var() SoundCue GraffitiSighted <SpeechEvent = GraffitiSighted>;
var() SoundCue GroundZero <SpeechEvent = GroundZero>;
var() SoundCue HackDoor <SpeechEvent = HackDoor>;
var() SoundCue HackDoorSuccess <SpeechEvent = HackDoorSuccess>;
var() SoundCue HackTurret <SpeechEvent = HackTurret>;
var() SoundCue HackTurretFailed <SpeechEvent = HackTurretFailed>;
var() SoundCue HackTurretSuccess <SpeechEvent = HackTurretSuccess>;
var() SoundCue HackUnit <SpeechEvent = HackUnit>;
var() SoundCue HackUnitFailed <SpeechEvent = HackUnitFailed>;
var() SoundCue HackUnitSuccess <SpeechEvent = HackUnitSuccess>;
var() SoundCue HackWorkstation <SpeechEvent = HackWorkstation>;
var() SoundCue HackWorkstationSuccess <SpeechEvent = HackWorkstationSuccess>;
var() SoundCue HaywireProtocol <SpeechEvent = HaywireProtocol>;
var() SoundCue HoldTheLine <SpeechEvent = HoldTheLine>;
var() SoundCue InitialFeedback <SpeechEvent = InitialFeedback>;
var() SoundCue Insanity <SpeechEvent = Insanity>;
var() SoundCue Inspire <SpeechEvent = Inspire>;
var() SoundCue InTheZone <SpeechEvent = InTheZone>;
var() SoundCue ItemCollected <SpeechEvent = ItemCollected>;
var() SoundCue KillZone <SpeechEvent = KillZone>;
var() SoundCue LootCaptured <SpeechEvent = LootCaptured>;
var() SoundCue LootSpotted <SpeechEvent = LootSpotted>;
var() SoundCue MeatFactorySighted <SpeechEvent = MeatFactorySighted>;
var() SoundCue MedicalProtocol <SpeechEvent = MedicalProtocol>;
var() SoundCue Mindblast <SpeechEvent = Mindblast>;
var() SoundCue MultipleTargetsKilled <SpeechEvent = MultipleTargetsKilled>;
var() SoundCue NullLance <SpeechEvent = NullLance>;
var() SoundCue NullShield <SpeechEvent = NullShield>;
var() SoundCue PickingUpBody <SpeechEvent = PickingUpBody>;
var() SoundCue PlasmaBlaster <SpeechEvent = PlasmaBlaster>;
var() SoundCue Poison <SpeechEvent = Poison>;
var() SoundCue Reaper <SpeechEvent = Reaper>;
var() SoundCue Reloading <SpeechEvent = Reloading>;
var() SoundCue RestorativeMist <SpeechEvent = RestorativeMist>;
var() SoundCue RocketLauncher <SpeechEvent = RocketLauncher>;
var() SoundCue SaturationFire <SpeechEvent = SaturationFire>;
var() SoundCue ShredderGun <SpeechEvent = ShredderGun>;
var() SoundCue ShredStormCannon <SpeechEvent = ShredStormCannon>;
var() SoundCue SmokeGrenade <SpeechEvent = SmokeGrenade>;
var() SoundCue SoldierFailsControl <SpeechEvent = SoldierFailsControl>;
var() SoundCue SoldierResistsMindControl <SpeechEvent = SoldierResistsMindControl>;
var() SoundCue SquadConcealmentBroken <SpeechEvent = SquadConcealmentBroken>;
var() SoundCue StunTarget <SpeechEvent = StunTarget>;
var() SoundCue SwordMiss <SpeechEvent = SwordMiss>;
var() SoundCue TakingDamage <SpeechEvent = TakingDamage>;
var() SoundCue TargetArmorHit <SpeechEvent = TargetArmorHit>;
var() SoundCue TargetEliminated <SpeechEvent = TargetEliminated>;
var() SoundCue TargetKilled <SpeechEvent = TargetKilled>;
var() SoundCue TargetMissed <SpeechEvent = TargetMissed>;
var() SoundCue TargetWinged <SpeechEvent = TargetWinged>;
var() SoundCue TeslaCannon <SpeechEvent = TeslaCannon>;
var() SoundCue ThroughTheWall <SpeechEvent = ThroughTheWall>;
var() SoundCue ThrowFlashbang <SpeechEvent = ThrowFlashbang>;
var() SoundCue ThrowGrenade <SpeechEvent = ThrowGrenade>;
var() SoundCue TurnWhileConfused <SpeechEvent = TurnWhileConfused>;
var() SoundCue VIPknockout <SpeechEvent = VIPknockout>;
var() SoundCue VIPRescueComplete <SpeechEvent = VIPRescueComplete>;
var() SoundCue VIPRescueInProgress <SpeechEvent = VIPRescueInProgress>;
var() SoundCue VoidRift <SpeechEvent = VoidRift>;
var() SoundCue Acid <SpeechEvent = Acid>;
var() SoundCue BleedingOut <SpeechEvent = BleedingOut>;
var() SoundCue CriticalFeedback <SpeechEvent = CriticalFeedback>;
var() SoundCue CriticallyWounded <SpeechEvent = CriticallyWounded>;
var() SoundCue EvacHeavyLosses <SpeechEvent = EvacHeavyLosses>;
var() SoundCue EvacNoLosses <SpeechEvent = EvacNoLosses>;
var() SoundCue EvacSomeLosses <SpeechEvent = EvacSomeLosses>;
var() SoundCue MissionAbortRequest <SpeechEvent = MissionAbortRequest>;
var() SoundCue ObjectFireSpreading <SpeechEvent = ObjectFireSpreading>;
var() SoundCue ObjectOnFire <SpeechEvent = ObjectOnFire>;
var() SoundCue SoldierFlanked <SpeechEvent = SoldierFlanked>;
var() SoundCue SoldierSuppressed <SpeechEvent = SoldierSuppressed>;
var() SoundCue SquadMemberDead <SpeechEvent = SquadMemberDead>;
var() SoundCue Burning <SpeechEvent = Burning>;
var() SoundCue PanicScream <SpeechEvent = PanicScream>;